----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    02:37:35 06/12/2020 
-- Design Name: 
-- Module Name:    mz80disp2 - gate 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.std_logic_unsigned.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mz80disp2 is
    Port ( ADCLK : in  STD_LOGIC;  -- VRAM address counter clock
           LATCH : in  STD_LOGIC;  -- buffer latch signal
           PRESET : in  STD_LOGIC; -- preset signal
           RESET : in  STD_LOGIC;  -- when '1' then reset buffer on latch
           SWITCH : in  STD_LOGIC; -- selector switch
           CPU_AD : in  STD_LOGIC_VECTOR (9 downto 0); -- cpu address inport
           VRAM_AD : out  STD_LOGIC_VECTOR (9 downto 0)); -- VRAM address outport
	attribute pin_assign : string;
	attribute pin_assign of adclk    : signal is "44";
	attribute pin_assign of latch    : signal is "43";
	attribute pin_assign of preset   : signal is "42";
	attribute pin_assign of reset    : signal is "38";
	attribute pin_assign of switch   : signal is "37";
	attribute pin_assign of cpu_ad   : signal is "14,13,12,8,7,6,5,3,2,1";
	attribute pin_assign of vram_ad  : signal is "20,21,22,27,28,29,30,31,32,33";
end mz80disp2;

architecture mz80disp2_arch of mz80disp2 is -- Internal signal declaration
	signal INT_BUFFER       : STD_LOGIC_VECTOR (9 downto 0) :="0000000000";
	signal INT_COUNTER      : STD_LOGIC_VECTOR (9 downto 0) :="0000000000";
	
begin

	VRAM_AD <= CPU_AD when SWITCH ='0' else INT_COUNTER ;

	COUNT: process (ADCLK) -- 10bit counter
	begin
		if (ADCLK'event and ADCLK='1') then
			if (PRESET = '1') then
				INT_COUNTER <= INT_BUFFER;
			else
				INT_COUNTER <= INT_COUNTER + 1;
			end if;
		end if;
	end process;

	BUFF_LATCH: process (LATCH) -- counter latch
	begin
		if (LATCH'event and LATCH='1') then
		   if (RESET = '1') then 
				INT_BUFFER <= "0000000000" ;
			else
				INT_BUFFER <= INT_COUNTER ;
			end if;
		end if;
	end process;

end mz80disp2_arch;

