/********************************************************/
/* AKI-80 VRAM BOARD LIBRARY HEADDER                    */
/*                                 source for HI-TECH C */
/* 2020.07.14                             (c)neko Java  */
/********************************************************/

#define VRM_IOPT	40H			/* VRAM control port address for ZASM */
#define VRM_BASE	0x9000		/* VRAM address base */
#define VRM_COUNT	1000		/* VRAM text screen size */
#define VRM_1KB		0x400		/* VRAM text memmory(1kb) */
#define VRM_TX		0x08		/* VRAM text mode mask(or) */
#define VRM_GR		0x30		/* VRAM graphic mode mask(and) */
#define VRM_ROW		0x78		/* VRAM row mask(and) */
#define VRM_PG		0x0F		/* VRAM page mask(and) */
#define VRM_TX_COL	40			/* VRAM text col length */
#define VRM_TX_ROW	25			/* VRAM text row length */
#define VRM_GR_X	320			/* VRAM pxel x length */
#define VRM_GR_Y	200			/* VRAM pxel y length */

void vram_text(char, char);
void vram_graph(char);
void vram_clear(void);
void vram_clear_1kb(void);	/* clear graph but use only 1kb area */
void vram_text_scroll(void);
void vram_pix_set(int, int);
void vram_pix_reset(int, int);
void vram_pix_bw(int, int, char);		/* 1:white, 0:black */
void vram_line_bw(int, int, int, int, char);	/* 1:white, 0:black */
void vram_line(int, int, int, int);
void vram_bline(int, int, int, int);
void vram_rect(int, int, int, int);
void vram_circle(int, int, int, char);
void vram_cur_set(unsigned int, unsigned int);
void vram_cur_inc(void);
void vram_cur_cr(void);
void vram_putdc(char);	/* put direct display code */
char vram_chg_code(char);	/* from ascii code to display code */
void vram_putch(char);
void vram_print(char *);
void vram_gput88(char *);	/* put 8*8 bit patern */
void vram_gput88_8kb(char *);	/* put 8*8 bit patern. possible bit operation */
void vram_g88_shift(int, int); /* 8*8 bit patter shift */
void vram_gputch(char);
void vram_gprint(char *);
char vram_read(int); /* 1byte vram read data. cursor base+row */
int vram_disp_img(char *);	/* Windows bitmap 320*200 1bit format */
